// Get demo #2 Collision Detection using get( )

color pixelColor, edgeColor;
int x, y, dim, dx, dy;
void setup( )
{
  size( 400, 400 );
  rectMode( CENTER );
  textAlign( CENTER );
  textSize( 18 );
  
  edgeColor = color( 255, 255, 0 ); // yellow
  
  x = y = width/2;
  dx = 1;
  dy = 4;
  dim = 40;
}

void draw( )
{
  prepareWindow( );
  moveBlock( );
  drawBlock( );
  showStats( );
}

void moveBlock( )
{
   x += dx;
   y += dy;

   color topColor = get( x, y-dim/2 );
   color bottomColor = get( x, y+dim/2 );
   color leftColor = get( x-dim/2, y );
   color rightColor = get( x+dim/2, y );
   
   if ( topColor == edgeColor || bottomColor == edgeColor) 
   {
      dy = -dy;
      y += dy;
   }
   if ( leftColor == edgeColor || rightColor == edgeColor)
   {
      dx = -dx;
      x += dx;
   } 
     
   text( "Left  Pixel Color: " + leftColor,  width/2, 250 ); 
   text( "Right Pixel Color: " + rightColor, width/2, 300 ); 
}

void drawBlock( )
{
   noStroke( );
   fill( 255, 0, 0 );
   rect( x, y, dim, dim );
   stroke( 255 );
   strokeWeight( 5 );
   point( x-dim/2, y );
   point( x+dim/2, y );
   point( x, y-dim/2 );
   point( x, y+dim/2 );
}

void showStats( )
{
  pixelColor = get( mouseX, mouseY );
  fill( 255 );
  text( "Edge Color: " + edgeColor, width/2, 350 );
  text( "Mouse Color: " + get( mouseX, mouseY), width/2, 375 );
}







void prepareWindow( )
{
   background( 0 );
   stroke( edgeColor);
   strokeWeight( 40 );
   noFill( );
   rect( width/2, height/2, width, height );

}
