// Get demo 3 Distance for color equality

float barX, barY, barWidth, barHeight;
float sliderWidth, sliderX;

float rotationAmount, rotationDelta;

color boxColor, pixelColor;

boolean colorEqual;

float colorThreshold = 110 ;

void setup( )
{
  size( 400, 400, OPENGL );
  rectMode( CENTER );
  textAlign( CENTER );
  textSize( 18 );
  barX = width/2;
  barY = height*.8;
  barWidth = width*.8;
  barHeight = height*.25;
  sliderX = width/2;
  sliderWidth = 5;
  
  boxColor = color( 255, 255, 0 );
  
  rotationAmount = 0 ;
  rotationDelta = 0;
  
  colorEqual = false;
}

void draw( )
{
  prepareWindow( );
  drawBlocks( );
  showSlider( );
  showStats( );
}

void drawBlocks( )
{
   stroke( 0 );
   fill( boxColor );
   box( 100 );
   noStroke( );
   pushMatrix( );
     translate( width/2, height*.4, 0 );
     rotationAmount += rotationDelta;
     rotateY( radians( rotationAmount ) ); 
     box( 100, 200, 50 ); 
   popMatrix( );
}

void showStats( )
{
  pixelColor = get( mouseX, mouseY );
  text("Reference Box Color: " + boxColor, barX, barY-30 );
  text("PixelColor:  " + pixelColor, barX, barY-10 );
  boolean sameColor = (pixelColor == boxColor);
  text("Color Match using ==: " + sameColor, barX, barY+10 );
  float rMouse = red(pixelColor);
  float gMouse = green(pixelColor);
  float bMouse = blue(pixelColor);
  float rRef = red(boxColor);
  float gRef = green(boxColor);
  float bRef = blue(boxColor);
  float colorDistance = dist( rMouse, gMouse, bMouse, rRef, gRef, bRef);
  text( "Color distance: " + int(colorDistance), barX, barY+25  );
  sameColor = colorDistance <= colorThreshold;
  text("Color Match using distance: " + sameColor, barX, barY+40);
}


void showSlider( )
{
  noStroke( );
  fill( 255, 0, 0 );
  rect( barX, barY, barWidth, barHeight );
  fill( 255 );
  rect( sliderX, barY, sliderWidth, barHeight );  
}


void mouseDragged( )
{
  if ( mouseX >= barX-barWidth/2  && mouseX <= barX+barWidth/2 &&
       mouseY >= barY-barHeight/2 && mouseY <= barY+barHeight/2 )
      {
        rotationDelta =  map(mouseX, barX-barWidth/2, barX+barWidth/2, -10, +10 );
        sliderX = mouseX;
      } 
}

void prepareWindow( )
{
   background( 0 );
   lights( );
   //directionalLight( 255, 255, 255, 1, 0, 0 );

   //lights( );
}
